@cpeek macro

.data
regs dd offset load_and_do_regs
mem dd offset load_and_do_mem
caller dd ?
cpeek_lib_handle dd ?
cpeek_info dd ?

.code
load_and_do_mem:
    pop caller    ;we must unload the return address before calling mem
    pushad
    pushfd
    call load_cpeek_dll
    popfd
    popad
    call mem       ;"mem" is now a code address in the dll
    jmp caller

load_and_do_regs:
    pushad
    pushfd
    call load_cpeek_dll
    popfd
    popad
    jmp regs  ;not "call" and "ret", for then the esp will be inaccurately reported

load_cpeek_dll:
    pushfd
    cld        ;LoadLibrary has trouble if the direction flag is set
    call @F           ;a trick for pushing the address of a read-only
    db "cpeek.dll",0   ;   string which does not require a name
@@: call LoadLibrary
    mov cpeek_lib_handle,eax   ;optional
    call @F
    db "info",0
@@: push eax
    call GetProcAddress
    mov cpeek_info,eax     ;optional
    push [eax+8]
    pop regs          ;thus the dll will not get loaded twice
    push [eax+0Ch]
    pop mem
    popfd
    ret

endm
